/**
 * @file
 * VuoList_VuoWrapMode C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoWrapMode_H
#define VuoList_VuoWrapMode_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoWrapMode VuoList_VuoWrapMode
 * A list of @ref VuoWrapMode elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoWrapMode
 * A list of @ref VuoWrapMode elements.
 */
#ifndef VuoList_VuoWrapMode_TYPE_DEFINED
typedef void * VuoList_VuoWrapMode;
#endif

/**
 * Creates a new list of @ref VuoWrapMode elements.
 */
VuoList_VuoWrapMode VuoListCreate_VuoWrapMode(void);

/**
 * Returns the @ref VuoWrapMode at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoWrapMode VuoListGetValueAtIndex_VuoWrapMode(const VuoList_VuoWrapMode list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoWrapMode(VuoList_VuoWrapMode list, const VuoWrapMode value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoWrapMode(VuoList_VuoWrapMode list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoWrapMode(VuoList_VuoWrapMode list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoWrapMode(const VuoList_VuoWrapMode list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoWrapMode VuoList_VuoWrapMode_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoWrapMode_jsonFromValue(const VuoList_VuoWrapMode value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoWrapMode_summaryFromValue(const VuoList_VuoWrapMode value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoWrapMode VuoList_VuoWrapMode_valueFromString(const char *str);
char * VuoList_VuoWrapMode_stringFromValue(const VuoList_VuoWrapMode value);
/// @}

/**
 * @}
 */

#endif
